﻿function FakeTextStreamContents(contents)
{
	var stream = new FakeTextStream;
	stream.ReadLineFakeResult = contents;
	return stream;
}

function FakeFileExists(fso, name, streamContents)
{
	fso.FileExistsFakeResult[name] = true;
	fso.OpenTextFileFakeResult[name] = FakeTextStreamContents(streamContents);
}

function TestIncludes()
{
	var fso = new FakeFileSystemObject;
	var analyzer = new IncludeAnalyzer;
	analyzer.m_includeDirs = [ "." ];
	analyzer.m_fso = fso;
	var output = [];
	analyzer.Echo = function(text)
	{
		output.push(text);
	}

	FakeFileExists(fso, "stdio.h",
		[
			"// this is stdio.h"
		]);
	FakeFileExists(fso, "Foo/Foo.h",
		[
			"#include <stdlib.h>"
		]);
	var input = FakeTextStreamContents([
		"#include <stdio.h>",
		"#include <Foo/Foo.h>"
	]);

	analyzer.ProcessFile(input);
	AssertEqual("stdio.h", output[0]);
	AssertEqual("Foo/Foo.h", output[1]);
	AssertEqual("  stdlib.h", output[2]);
}
